SystemOrganization addCategory: #TusLibrosDotCom!

Object subclass: #ItemCatalogue
	instanceVariableNames: 'catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!ItemCatalogue methodsFor: 'operating' stamp: 'GabrielFinkelstein 6/12/2012 21:05'!
addItem: anItem

	catalogue add: anItem.! !

!ItemCatalogue methodsFor: 'operating' stamp: 'GabrielFinkelstein 6/12/2012 21:53'!
includesItem: anItem

	^catalogue includes: anItem.! !

!ItemCatalogue methodsFor: 'initializing' stamp: 'GabrielFinkelstein 6/12/2012 21:05'!
initialize

	catalogue:= Set new! !

Object subclass: #ShoppingCart
	instanceVariableNames: 'catalogue contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!ShoppingCart class methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/12/2012 01:21'!
newWithCatalogue: anItemCatalogue

^self new initializeWithCatalogue: anItemCatalogue! !

!ShoppingCart methodsFor: 'initializing' stamp: 'GabrielFinkelstein 6/12/2012 22:06'!
addItem: anItem withQuantity: anInteger

	(catalogue includesItem: anItem) ifFalse:[^self error].
	contents add: anItem withOccurrences: anInteger.

! !

!ShoppingCart methodsFor: 'accesing' stamp: 'Balmaceda 6/12/2012 01:22'!
contents
"Devuelve el contenido del carrito"

^contents

! !

!ShoppingCart methodsFor: 'initializing' stamp: 'GabrielFinkelstein 6/12/2012 21:43'!
initializeWithCatalogue: anItemCatalogue

contents:= Bag new.
catalogue:= anItemCatalogue.! !

!ShoppingCart methodsFor: 'accesing' stamp: 'GabrielFinkelstein 6/12/2012 21:49'!
quantityOf: anItem

	^contents occurrencesOf: anItem.

! !

TestCase subclass: #TusLibrosDotComTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!TusLibrosDotComTest methodsFor: 'errors' stamp: 'Balmaceda 6/12/2012 02:19'!
canNotAddInvalidItemToCartException

^Error. 


! !

!TusLibrosDotComTest methodsFor: 'shopping cart' stamp: 'Balmaceda 6/11/2012 03:43'!
newCart

^ShoppingCart newWithCatalogue: self tusLibrosDotComCatalogue.


! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'Balmaceda 6/11/2012 03:28'!
test01ANewCartShouldBeEmpty

	self assert: self newCart contents isEmpty.


! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'GabrielFinkelstein 6/12/2012 22:15'!
test02AddingItemsToCartShouldReturnACartThatIncludesTheAddedItems

	| a |
	
	a:= self newCart addItem: '11111' withQuantity: 1;
					  addItem: '22222' withQuantity: 3.

      self assert: (a quantityOf: '11111') = 1.
	self assert: (a quantityOf: '22222') = 3.


! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'GabrielFinkelstein 6/12/2012 22:17'!
test03ACartShouldNotContainAnItemThatWasNotAddedToIt

	| a |

	a:= self newCart addItem: '11111' withQuantity: 1.
	self assert: (a quantityOf: '22222') = 0.



! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'GabrielFinkelstein 6/12/2012 22:10'!
test04AddingTheSameItemMoreThanOnceToCartShouldReturnACartThatIncludesTheSumOfTheQuantitiesAddedForSuchItem

	| a |

	a:= self newCart addItem: '11111' withQuantity: 2;
                          addItem: '11111' withQuantity: 3. 
	self assert: (a quantityOf: '11111') = 5.



! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'GabrielFinkelstein 6/12/2012 22:13'!
test05AddingAnInvalidItemToCartShouldReturnAnError

self should: [ self newCart addItem: 'INVALID_ITEM' withQuantity: 2 ] raise: self canNotAddInvalidItemToCartException.



! !

!TusLibrosDotComTest methodsFor: 'catalogue' stamp: 'GabrielFinkelstein 6/12/2012 21:03'!
tusLibrosDotComCatalogue

^ItemCatalogue new addItem:'11111';
                                addItem:'22222'.


! !
